import es, playerlib, random, gamethread

### Start Config ###
bad_weapons = ['awp', 'g3sg1', 'sg550']
#Weapons you wish to punish players for using. Use same format to add/remove weapons from list.
punishment = "stripallguns"
#Options: kill, slap, burn, striparmor, stripgun, or stripallguns.
slap_damage = 50
#This will take away 50 from Health total NOT armor.
burn_time = 20
#burn time is in seconds
rename_player = "1337 N00b"
#This will name the punishened player anything you wish.
### End Config ###

def load():
    es.doblock ('corelib/noisy_on')
    # es.doblock() is a function, so it requires perenthesis around the parameter

def unload():
    es.doblock('corelib/noisy_off')
    # es.doblock() is a function, so it requires perenthesis around the parameter

def round_start(ev):
    es.msg("#multi", "#defaultNON-TOLERATED WEAPONS:#green", bad_weapons)

def weapon_fire(ev):
    if ev['weapon'] in bad_weapons:
        es.tell(ev['userid'], "You have been punished for using a non-tolerated weapon.")
	userid = ev['userid']
        if punishment == "kill":
            forcesuicide(userid)
            # We can run local methods like this instead of doblock
        elif punishment == "slap":
            slap(userid)
        elif punishment == "burn":
            burn(userid)
        elif punishment == "striparmor":
            striparmor(userid)
        elif punishment == "stripgun":
            stripgun(userid)
        elif punishment == "stripallguns":
             stripallguns(userid)
        elif punishment == "changename":
            changename(userid)
        # elif stands for else if, which just lowers the number of iterations

def forcesuicide(userid):
    es.sexec(userid, "kill")

def slap(userid):
    player = playerlib.getPlayer(userid)
    player.set("health", player.get("health") - slap_damage)
    es.emitsound("player", userid, 'player/damage2.wav', '1.0', '0.5')
    es.setplayerprop(userid, 'CCSPlayer.baseclass.localdata.m_vecBaseVelocity', '%s,%s,%s'%(random.randint(-255, 255), random.randint(-255, 255), random.randint(-100, 255)))
    if player.get("health") <= 0:
            es.sexec(userid, "kill")

def striparmor(userid):
    player = playerlib.getPlayer(userid)
    player.set("armor", 0)

def stripgun(userid):
    player = playerlib.getPlayer(userid)
    weapon = player.attributes["weapon"]
    es.server.queuecmd('es_xremove %s' % weapon)

def burn(userid):
    es.server.queuecmd('es_xfire %s !self ignite' % userid)
    gamethread.delayed(burn_time, extinguish, userid)

def extinguish(userid): # Thanks to Freddukes
	napalmlist = es.createentitylist('entityflame')
	handle = es.getplayerhandle(userid)
	for flame_entity in napalmlist:
		string = es.getindexprop(flame_entity, 'CEntityFlame.m_hEntAttached')
		if string == handle:
			es.setindexprop(flame_entity, 'CEntityFlame.m_flLifetime', 0)
			es.cexec(userid, 'r_screenoverlay ""')
			es.server.queuecmd('es_xfire %s !self DispatchEffect WaterSurfaceExplosion'%userid)
			break

def stripallguns(userid):
    gamethread.delayed(0.1, es.server.queuecmd('es_give %s weapon_knife'%userid))
    handle  = es.getplayerhandle(userid)
    entlist = es.createentitylist()

    for index in entlist:
        if entlist[index]['classname'].startswith('weapon_'):
            if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == handle:
                es.server.cmd('es_xremove %s' % index)

def changename(userid):
    es.cexec(userid, "name", rename_player)